#include "p2k/p2klib.h"

#include <stdio.h>

#define BLOCK_SIZE	8192

void calc_addr(const char* name, size_t base, size_t size, size_t xfer)
{
  size_t left = size % BLOCK_SIZE;  
  size_t blocks = size / BLOCK_SIZE;
  size_t last = base + size - (left ? left : BLOCK_SIZE);
  size_t lxfer = xfer + 6 * (last - base) / BLOCK_SIZE;
  char cmd[64];
  
  printf("-- CODEGROUP %s --\n", name);
  printf("size : %i (%i blocks", size, blocks);
  if (left) printf(" + %i bytes", left);
  printf(")\n");
  printf("base : %.8X (%i)\t-> USB xfer %i\n", base, base, xfer);
  sprintf(cmd, "%cADDR%c%.8X", 0x02, 0x1e, base);
  hexprint(cmd, 14);
  printf("last : %.8X (%i)\t-> USB xfer %i\n", last, last, lxfer);
  sprintf(cmd, "%cADDR%c%.8X", 0x02, 0x1e, last);
  hexprint(cmd, 14);
}

int main()
{
  calc_addr( "CG01", 0x100400C8, 14233616, 115);
  calc_addr( "CG02", 0x11580000, 31457280, 10542);
  calc_addr( "CG04", 0x11380000, 1421448,  33582);
  calc_addr( "CG05", 0x1104C4C8, 1782584,  34625);
  calc_addr( "CG08", 0x13F40000, 262144,   35932);
  calc_addr( "CG15", 0x11200000, 1486856,  36124);
  calc_addr( "CG17", 0x1101A4C8, 148704,   37215);
  calc_addr( "CG18", 0x111FF800, 2048,     37327);
  
  return 0;
}
