/*
 * flash-tools - a set of tools for flashing handsets
 * Copyright (C) 2005 Jeremy Lain <jeremy.laine@m4x.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#ifndef P2K_FLASHCMD
#define P2K_FLASHCMD

#include "p2kdev.h"

#define FCMD_BEG                0x02
#define FCMD_END                0x03
#define FCMD_SEP		0x1e

int flash_checkresp(const char *resp_bytes, const size_t resp_len, const char *check_bytes, const size_t check_len);

int flash_cmd(p2k_dev_handle *dev_handle, char* bytes, size_t size, char *read_bytes, int *read_len, const int timeout);
int flash_cmd_simple(p2k_dev_handle *dev_handle, const char *cmd, char *read_bytes, int *read_len, const int timeout);

int flash_cmd_ADDR(p2k_dev_handle *dev_handle, const size_t naddr);
int flash_cmd_ERASE(p2k_dev_handle *flash_handle);
int flash_cmd_BIN(p2k_dev_handle *dev_handle, char *data, const size_t datalen);
int flash_cmd_JUMP(p2k_dev_handle *flash_handle, const size_t addr);
int flash_cmd_RESTART(p2k_dev_handle *flash_handle);
int flash_cmd_RQCS(p2k_dev_handle *flash_handle);
int flash_cmd_RQHW(p2k_dev_handle *flash_handle);
int flash_cmd_RQRC(p2k_dev_handle *flash_handle, size_t flashbase, size_t donebytes);
int flash_cmd_RQRCS(p2k_dev_handle *flash_handle, size_t addrbase, size_t bytes);
int flash_cmd_RQSF(p2k_dev_handle *flash_handle);
int flash_cmd_RQSN(p2k_dev_handle *flash_handle);
int flash_cmd_RQVN(p2k_dev_handle *flash_handle);
int flash_cmd_RQxx(p2k_dev_handle *flash_handle, const char *subcmd, const char *resp, const int timeout);
int flash_cmd_UPGRADE(p2k_dev_handle *flash_handle);

#endif
