/*
 * flash-tools - a set of tools for flashing handsets
 * Copyright (C) 2005 Jeremy Lain <jeremy.laine@m4x.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef P2K_FLASHOPS
#define P2K_FLASHOPS
 
#include "p2kdev.h"
#include "p2klib.h"

struct shx_header 
{
  unsigned char type[256];
  unsigned char v1[32];
  unsigned char v2[32];
  unsigned char date[128];
  unsigned char info[256];
  unsigned char unkn1[80];
  unsigned char v3[160];
  unsigned char unkn2[64];  
 };

#define MAX_CAT_SIZE  256
  
typedef struct
{
  size_t address;
  char filename[MAX_PATH];  
} flashcat_entry;

int flashcat_write_entry(FILE *fp, flashcat_entry *entry);
int flashcat_read_entry(FILE *fp, flashcat_entry *entry);
int flashcat_flash(p2k_dev_handle *flash_handle, const char* catalogfile, const size_t cg0break);

void print_shx_info(const struct shx_header *hdr);

int flash_checksum(p2k_dev_handle *dev_handle, flashcat_entry* codegroups, size_t cgcnt);
int flash_file(p2k_dev_handle *dev_handle, const char* filename, const size_t flashbase, const size_t skip);
int flash_prepare(p2k_dev_handle *dev_handle);
int flash_ramloader(p2k_dev_handle *dev_handle, const char* filename, const size_t flashbase);
int flash_split_1ff(const char *shxfile);

#endif
