/*
 * flash-tools - a set of tools for flashing handsets
 * Copyright (C) 2005 Jeremy Lain <jeremy.laine@m4x.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef P2K_P2KLIB_H
#define P2K_P2KLIB_H

#include <sys/time.h>

#ifdef _WIN32
struct timezone {
    int tz_minuteswest; /* minutes W of Greenwich */
    int tz_dsttime;     /* type of dst correction */
};
int gettimeofday(struct timeval *tvp, struct timezone *tzp);
#include <windows.h>
#define sleep(t)  Sleep((t) * 1000)
#endif

#ifndef MAX_PATH
#define MAX_PATH 1024
#endif

#define RET_OK  1
#define RET_ERR 0

void hexprint(const char* bytes, const int size);

unsigned char shx_conv_char(const char a);
void shx_conv_chars(const char* chars, char* bytes, const int size);

char * base_name (char const *name);
void root_name(char const *name, char *rootname);

void timer_time(struct timeval *tstart);
double timer_elapsed(struct timeval tstart);

#endif
